-------------------------------------------------------------------------------
-- global variables
-------------------------------------------------------------------------------
-- NORMAL 0
-- SEASON 1
-- SPECIAL 2
-- MONSTER 3
-- ACE 4

-- TEAM_YEAR				0
-- TEAM							1
-- YEAR							2
-- DUAL_TEAM_YEAR		3
-- DUAL_TEAM				4
-- DUAL_YEAR				5

-- 덱 종류별 보너스 스탯 수치
local deckStats = {}
deckStats[0] = {
	S = {15, 0}, A = {9, 0}, B = {6, 0}, C = {3, 0}
}
deckStats[1] = {
	S = {10, 0}, A = {6, 0}, B = {4, 0}, C = {1, 0}
}
deckStats[2] = {
	S = {8, 0}, A = {5, 0}, B = {3, 0}, C = {1, 0}
}
deckStats[3] = {
	S = {0, 0}
}
deckStats[4] = {
	S = {6, 4}
}
deckStats[5] = {
	S = {0, 0}
}

-- 팀 정보
local teamInfos = {}

-- ARI
teamInfos["ARI"] = {
	name = "ARI"
	, mainTeamCode = "ARI"
	, seasonTeamCodes = {ARI = true}
	, familyTeamCodes = {ARI = true}
	, shortTeamCode = "ARI"
}

-- ATL
teamInfos["ATL"] = {
	name = "ATL"
	, mainTeamCode = "ATL"
	, seasonTeamCodes = {ATL = true}
	, familyTeamCodes = {ATL = true}
	, shortTeamCode = "ATL"
}

-- BAL
teamInfos["BAL"] = {
	name = "BAL"
	, mainTeamCode = "BAL"
	, seasonTeamCodes = {BAL = true}
	, familyTeamCodes = {BAL = true}
	, shortTeamCode = "BAL"
}

-- BOS
teamInfos["BOS"] = {
	name = "BOS"
	, mainTeamCode = "BOS"
	, seasonTeamCodes = {BOS = true}
	, familyTeamCodes = {BOS = true}
	, shortTeamCode = "BOS"
}

-- CHC
teamInfos["CHC"] = {
	name = "CHC"
	, mainTeamCode = "CHC"
	, seasonTeamCodes = {CHC = true}
	, familyTeamCodes = {CHC = true}
	, shortTeamCode = "CHC"
}

-- CHW
teamInfos["CHW"] = {
	name = "CHW"
	, mainTeamCode = "CHW"
	, seasonTeamCodes = {CHW = true}
	, familyTeamCodes = {CHW = true}
	, shortTeamCode = "CHW"
}

-- CIN
teamInfos["CIN"] = {
	name = "CIN"
	, mainTeamCode = "CIN"
	, seasonTeamCodes = {CIN = true}
	, familyTeamCodes = {CIN = true}
	, shortTeamCode = "CIN"
}

-- CLE
teamInfos["CLE"] = {
	name = "CLE"
	, mainTeamCode = "CLE"
	, seasonTeamCodes = {CLE = true}
	, familyTeamCodes = {CLE = true}
	, shortTeamCode = "CLE"
}

-- COL
teamInfos["COL"] = {
	name = "COL"
	, mainTeamCode = "COL"
	, seasonTeamCodes = {COL = true}
	, familyTeamCodes = {COL = true}
	, shortTeamCode = "COL"
}

-- DET
teamInfos["DET"] = {
	name = "DET"
	, mainTeamCode = "DET"
	, seasonTeamCodes = {DET = true}
	, familyTeamCodes = {DET = true}
	, shortTeamCode = "DET"
}

-- HOU
teamInfos["HOU"] = {
	name = "HOU"
	, mainTeamCode = "HOU"
	, seasonTeamCodes = {HOU = true}
	, familyTeamCodes = {HOU = true}
	, shortTeamCode = "HOU"
}

-- KC
teamInfos["KC"] = {
	name = "KC"
	, mainTeamCode = "KC"
	, seasonTeamCodes = {KC = true}
	, familyTeamCodes = {KC = true}
	, shortTeamCode = "KC"
}

-- LAA
teamInfos["LAA"] = {
	name = "LAA"
	, mainTeamCode = "LAA"
	, seasonTeamCodes = {LAA = true}
	, familyTeamCodes = {LAA = true, ANA = true}
	, shortTeamCode = "LAA"
}

-- LAD
teamInfos["LAD"] = {
	name = "LAD"
	, mainTeamCode = "LAD"
	, seasonTeamCodes = {LAD = true}
	, familyTeamCodes = {LAD = true}
	, shortTeamCode = "LAD"
}

-- MIA
teamInfos["MIA"] = {
	name = "MIA"
	, mainTeamCode = "MIA"
	, seasonTeamCodes = {MIA = true}
	, familyTeamCodes = {MIA = true, FLA = true}
	, shortTeamCode = "MIA"
}

-- MIL
teamInfos["MIL"] = {
	name = "MIL"
	, mainTeamCode = "MIL"
	, seasonTeamCodes = {MIL = true}
	, familyTeamCodes = {MIL = true}
	, shortTeamCode = "MIL"
}

-- MIN
teamInfos["MIN"] = {
	name = "MIN"
	, mainTeamCode = "MIN"
	, seasonTeamCodes = {MIN = true}
	, familyTeamCodes = {MIN = true}
	, shortTeamCode = "MIN"
}

-- NYM
teamInfos["NYM"] = {
	name = "NYM"
	, mainTeamCode = "NYM"
	, seasonTeamCodes = {NYM = true}
	, familyTeamCodes = {NYM = true}
	, shortTeamCode = "NYM"
}

-- NYY
teamInfos["NYY"] = {
	name = "NYY"
	, mainTeamCode = "NYY"
	, seasonTeamCodes = {NYY = true}
	, familyTeamCodes = {NYY = true}
	, shortTeamCode = "NYY"
}

-- OAK
teamInfos["OAK"] = {
	name = "OAK"
	, mainTeamCode = "OAK"
	, seasonTeamCodes = {OAK = true}
	, familyTeamCodes = {OAK = true}
	, shortTeamCode = "OAK"
}

-- PHI
teamInfos["PHI"] = {
	name = "PHI"
	, mainTeamCode = "PHI"
	, seasonTeamCodes = {PHI = true}
	, familyTeamCodes = {PHI = true}
	, shortTeamCode = "PHI"
}

-- PIT
teamInfos["PIT"] = {
	name = "PIT"
	, mainTeamCode = "PIT"
	, seasonTeamCodes = {PIT = true}
	, familyTeamCodes = {PIT = true}
	, shortTeamCode = "PIT"
}

-- SD
teamInfos["SD"] = {
	name = "SD"
	, mainTeamCode = "SD"
	, seasonTeamCodes = {SD = true}
	, familyTeamCodes = {SD = true}
	, shortTeamCode = "SD"
}

-- SEA
teamInfos["SEA"] = {
	name = "SEA"
	, mainTeamCode = "SEA"
	, seasonTeamCodes = {SEA = true}
	, familyTeamCodes = {SEA = true}
	, shortTeamCode = "SEA"
}

-- SF
teamInfos["SF"] = {
	name = "SF"
	, mainTeamCode = "SF"
	, seasonTeamCodes = {SF = true}
	, familyTeamCodes = {SF = true}
	, shortTeamCode = "SF"
}

-- STL
teamInfos["STL"] = {
	name = "STL"
	, mainTeamCode = "STL"
	, seasonTeamCodes = {STL = true}
	, familyTeamCodes = {STL = true}
	, shortTeamCode = "STL"
}

-- TB
teamInfos["TB"] = {
	name = "TB"
	, mainTeamCode = "TB"
	, seasonTeamCodes = {TB = true}
	, familyTeamCodes = {TB = true}
	, shortTeamCode = "TB"
}

-- TEX
teamInfos["TEX"] = {
	name = "TEX"
	, mainTeamCode = "TEX"
	, seasonTeamCodes = {TEX = true}
	, familyTeamCodes = {TEX = true}
	, shortTeamCode = "TEX"
}

-- TEX
teamInfos["TOR"] = {
	name = "TOR"
	, mainTeamCode = "TOR"
	, seasonTeamCodes = {TOR = true}
	, familyTeamCodes = {TOR = true}
	, shortTeamCode = "TOR"
}

-- WSH
teamInfos["WSH"] = {
	name = "WSH"
	, mainTeamCode = "WSH"
	, seasonTeamCodes = {WSH = true}
	, familyTeamCodes = {WSH = true, MON = true}
	, shortTeamCode = "WSH"
}

-- ANA
teamInfos["ANA"] = {
	name = "ANA"
	, mainTeamCode = "LAA"
	, seasonTeamCodes = {LAA = true}
	, familyTeamCodes = {LAA = true, ANA = true}
	, shortTeamCode = "ANA"
}

-- MON
teamInfos["MON"] = {
	name = "MON"
	, mainTeamCode = "WSH"
	, seasonTeamCodes = {WSH = true}
	, familyTeamCodes = {WSH = true, MON = true}
	, shortTeamCode = "MON"
}

-- MON
teamInfos["FLA"] = {
	name = "FLA"
	, mainTeamCode = "MIA"
	, seasonTeamCodes = {MIA = true}
	, familyTeamCodes = {MIA = true, FLA = true}
	, shortTeamCode = "FLA"
}

-- 덱 선수 구성 조건
local deckConds = {
	S = 19, A = 10, B = 5, C = 3
}

local shortTeamCodes = {}
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
-- variable 가공
-------------------------------------------------------------------------------
for teamCode, teamInfo in pairs(teamInfos)
do
	shortTeamCodes[teamInfo.shortTeamCode] = teamCode
end
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
-- 외부 노출용 함수
-------------------------------------------------------------------------------

-- 현재 로스터에서 사용 가능한 덱 목록 반환
function getAvailableDecks(players, deckParams)
	local currDeck = convertToDeck(deckParams)

	-- 중복 검사를 피하기 위한 체크 리스트
	local teamYearChecked = {}
	local teamChecked = {}
	local yearChecked = {}
	
	local decks = {}

	for i, p in ipairs(players)
	do
		-- 시즌, 에이스 선수는 무시
		if p.playerType ~= ACE then			
			-- 팀연도덱 체크
			local key = p.teamCode .. p.year
			if not teamYearChecked[key] then
				teamYearChecked[key] = true
				
				local playerIds, seasonIds, aceIds, monsterIds = getTeamYearDeckPlayers(players, p.teamCode, p.year)				
				addDeckIfAvailable(decks, TEAM_YEAR, p.teamCode, p.year, playerIds, seasonIds, aceIds, monsterIds)
			end
			
			-- 팀덱 체크
			local teamCode = teamInfos[p.teamCode].mainTeamCode
			if not teamChecked[teamCode] then
				teamChecked[teamCode] = true
				
				local playerIds, seasonIds, aceIds, monsterIds = getTeamDeckPlayers(players, teamCode)
				addDeckIfAvailable(decks, TEAM, teamCode, nil, playerIds, seasonIds, aceIds, monsterIds)
			end
			
			-- 연도덱 체크
			if not yearChecked[p.year] then
				yearChecked[p.year] = true
				
				local playerIds, seasonIds, aceIds, monsterIds = getYearDeckPlayers(players, p.year)
				addDeckIfAvailable(decks, YEAR, nil, p.year, playerIds, seasonIds, aceIds, monsterIds)
			end
			
		end
	end

	-- 팀덱 대표팀 세팅 (패밀리 팀이 있을 경우 선수가 더 많은 팀을 우선시함)
	-- local teamDecks = filterDecksByType(decks, TEAM)
	-- processTeamDeck(teamDecks, players)
	
	-- 듀얼 팀덱 세팅
	-- addDualDecks(decks, teamDecks)
	
	-- 최종 반환할 덱 목록 생성
	decks = makeTotalDeckList(decks, currDeck)
	
	-- 스탯, 이름 정보 세팅
	for i, deck in ipairs(decks)
	do
		setInfoToDeck(deck)
	end
	
	-- debug
	--dumpList(decks)
	
	return decks 
end

-- 덱 정보 반환
function getDeckInfo(deckParams)
	local deck = convertToDeck(deckParams)

	setInfoToDeck(deck)	

	return deck
end

-- 덱 조건에 맞는 선수 목록과 버프 스탯을 반환
function getDeckApplicablePlayers(players, deckParams)
	local playerStatMap = {}

	local deck = convertToDeck(deckParams)
	if not deck then
		return playerStatMap
	end
	
	local mainStat, subStat = getStat(deck)
	
	local playerIds, seasonIds, aceIds
	
	if deck.type == DUAL_TEAM then
		local mainTeamCode, subTeamCode = splitTeamCode(deck.teamCode)
		
		-- 시즌 선수 호환 팀끼리의 듀얼이면 시즌 선수는 소속 팀에만 속하도록 함
		local allowSeasonFamilyTeam = checkAllowSeasonFamilyTeam(mainTeamCode, subTeamCode)
		
		-- 메인 덱 선수 세팅
		playerIds, seasonIds, aceIds = getTeamDeckPlayers(players, mainTeamCode, allowSeasonFamilyTeam)
		putAllPlayerStatMap(playerStatMap, playerIds, seasonIds, aceIds, mainStat)
				
		-- 서브 덱 선수 세팅
		playerIds, seasonIds, aceIds = getTeamDeckPlayers(players, subTeamCode, allowSeasonFamilyTeam)
		putAllPlayerStatMap(playerStatMap, playerIds, seasonIds, aceIds, subStat)
	else
		-- 팀연도, 팀, 연도 덱의 경우 해당된 플레이어 목록에서 mainStat만 적용해서 반환
		
		if deck.type == TEAM_YEAR then
			playerIds, seasonIds, aceIds = getTeamYearDeckPlayers(players, deck.teamCode, deck.year)
		elseif deck.type == TEAM then
			playerIds, seasonIds, aceIds = getTeamDeckPlayers(players, deck.teamCode)
		elseif deck.type == YEAR then
			playerIds, seasonIds, aceIds = getYearDeckPlayers(players, deck.year)
		end
		
		putAllPlayerStatMap(playerStatMap, playerIds, seasonIds, aceIds, mainStat)
	end
	
	return playerStatMap	
end

-- 덱 조건 설명 반환
function getDeckCond(players, deckParams)
	local deck = convertToDeck(deckParams)
	
	local teamInfo = teamInfos[deck.teamCode]
	
	local cond = {}
	
	if deck.type == TEAM_YEAR then
		cond.mainTeamCode = deck.teamCode		

		cond.mainDescr = string.format( DECK_DESC_FORMAT_TEAM_YEAR, tostring(deck.year), teamInfos[deck.teamCode].name, deckConds[deck.grade])
		cond.mainPlayerCnt = getTeamYearDeckPlayerCount(players, deck.teamCode, deck.year)
		
	elseif deck.type == TEAM then
		cond.mainTeamCode = deck.teamCode
		cond.mainDescr = getTeamDeckCondStr(deck.teamCode, deckConds[deck.grade])
		cond.mainPlayerCnt = getTeamDeckPlayerCount(players, deck.teamCode)
		
	elseif deck.type == YEAR then
		cond.mainTeamCode = "mlb"
		cond.mainDescr = string.format( DECK_DESC_FORMTAT_COMMON, tostring(deck.year), deckConds[deck.grade])
		cond.mainPlayerCnt = getYearDeckPlayerCount(players, deck.year)
		
	elseif deck.type == DUAL_TEAM then
		local mainTeamCode, subTeamCode = splitTeamCode(deck.teamCode)
		
		-- 시즌 선수 호환 팀끼리의 듀얼이면 시즌 선수는 소속 팀에만 속하도록 함
		local allowSeasonFamilyTeam = checkAllowSeasonFamilyTeam(mainTeamCode, subTeamCode)
		
		cond.subTeamCode = subTeamCode
		cond.subDescr = getDualTeamDeckCondStr(subTeamCode, 5, 9)
		cond.subPlayerCnt = getTeamDeckPlayerCount(players, subTeamCode, allowSeasonFamilyTeam)
		
		cond.mainTeamCode = mainTeamCode
		cond.mainDescr = getDualTeamDeckCondStr(mainTeamCode, 19 - cond.subPlayerCnt)
		cond.mainPlayerCnt = getTeamDeckPlayerCount(players, mainTeamCode, allowSeasonFamilyTeam)
		
	end

	return cond
end
-------------------------------------------------------------------------------

-- 현재 덱 정보 생성
function convertToDeck(deckParams)
	local teamCode = deckParams.teamCode
	local year = deckParams.year
	local grade = deckParams.grade

	local type = nil
	
	if teamCode and year then
		type = TEAM_YEAR
		
	elseif teamCode then
		-- + 기호가 있을 경우엔 듀얼 팀덱
		local index = string.find(teamCode, "+")
		if index then
			type = DUAL_TEAM
		else
			type = TEAM
		end		
	elseif year then
		type = YEAR
	end
	
	if not type then
		return nil
	end
	
	return {type = type, teamCode = teamCode, year = year, grade = grade, available = true}
end

-- 적용가능한 덱이 있을 경우 리스트에 추가
function addDeckIfAvailable(decks, type, teamCode, year, playerIds, seasonIds, aceIds, monsterIds)
	local deck = makeDeck(type, teamCode, year, playerIds, seasonIds, aceIds, monsterIds)
	if deck then
		table.insert(decks, deck)
	end
end

-- 적용가능한 가장 상위 덱 생성
function makeDeck(type, teamCode, year, playerIds, seasonIds, aceIds, monsterIds)
	local total = #playerIds + #seasonIds + #aceIds
	
	-- 해당 조건의 선수가 2명 미만이면 해당 조건에 맞는 덱은 없음
	if total < 2 then
		return nil
	end
  	
	local deck = {
		type = type
		, teamCode = teamCode
		, year = year
		, total = total
		, playerCnt = #playerIds
		, seasonCnt = #seasonIds
		, aceCnt = #aceIds
	}
	
	if total >= deckConds.S then
		deck.grade = "S"
		deck.available = true
	elseif total >= deckConds.A then
		deck.grade = "A"
		deck.available = true
	elseif total >= deckConds.B then
		deck.grade = "B"
		deck.available = true
	else
		deck.grade = "C"
		deck.available = total >= deckConds.C
	end

    -- 모든덱 10몬 제한
	if #monsterIds > 10 then
		deck.available = false
	end
  
	return deck
end

-- 팀덱 메인 팀 세팅
function processTeamDeck(decks, players)
	for i, deck in ipairs(decks)
	do
		local familyTeamCodes = teamInfos[deck.teamCode].familyTeamCodes
			
		local countMap = {}
			
		for j, p in ipairs(players)
		do
			if familyTeamCodes[p.teamCode] then
				if countMap[p.teamCode] then
					countMap[p.teamCode] = countMap[p.teamCode] + 1
				else
					countMap[p.teamCode] = 1
				end
			end	
		end
		
		deck.teamCode = getMaxTeamCode(countMap, teamInfos[deck.teamCode].mainTeamCode)

	end
end

-- 가장 많은 카운트의 팀 코드 반환
function getMaxTeamCode(countMap, mainTeamCode)
	local maxCnt = 0
	local teamCode = nil
	
	for k, v in pairs(countMap)
	do
		if v > maxCnt then
			maxCnt = v
			teamCode = k
		elseif v == maxCnt and teamCode ~= mainTeamCode then
			-- haitai 5명, kia 5명일 경우 kia를 우선해주기 위해서 처리
			teamCode = mainTeamCode
		end
	end
	
	return teamCode
end

-- 덱 타입에 따라 필터링된 결과 반환
function filterDecksByType(decks, type)
	local result = {}
	
	for i, deck in ipairs(decks)
	do
		if deck.type == type then
			table.insert(result, deck)
		end
	end
	
	return result
end

-- 팀덱에서 조합 가능한 듀얼 팀덱을 전체 덱 목록에 추가
function addDualDecks(decks, teamDecks)
	-- 팀덱이 두개 미만일 경우 조합 가능한 듀얼팀덱 없음
	local size = #teamDecks
	if size < 2 then
		return
	end
	
	-- 내림차순 정렬
	sortDecksByTotal(teamDecks)
	 
	for i = 1, size - 1
	do
		for j = i + 1, size
		do
			local d1 = teamDecks[i]
			local d2 = teamDecks[j]
			
			-- 넥센/현대와 같이 시즌 선수를 호환할 경우 시즌 선수는 원 소속팀에만 카운트 되도록 설정
			if not checkAllowSeasonFamilyTeam(d1.teamCode, d2.teamCode) then
				d1 = resetSeasonPlayerCnt(d1)
				d2 = resetSeasonPlayerCnt(d2)

				-- 시즌 선수 리셋으로 total 갯수가 변경될 수 있기 때문에 d1이 언제나 d2 보다 크도록 설정				
				if d1.total < d2.total then
					local tmp = d1
					d1 = d2
					d2 = tmp
				end
			end
			
			local total = d1.total + d2.total
			
			if d1.total >= 10 and d2.total >= 5 and total >= 19 then
				-- 두 팀덱의 합이 듀얼팀 조건에 맞을 경우 생성
				table.insert(decks, makeDualDeck(d1, d2))
			elseif d1.total > d2.total and d2.total >= 5 then
				-- 듀얼덱 구성은 안되었지만 UI에 노출하는 조건이 만족할 경우 생성
				table.insert(decks, makeDualDeck(d1, d2))
			end
			
		end
	end
	
end

function makeDualDeck(deck1, deck2)
	local teamCode = teamInfos[deck1.teamCode].shortTeamCode .. "+" .. teamInfos[deck2.teamCode].shortTeamCode			
	local total = deck1.total + deck2.total
	
	return {
		type = DUAL_TEAM
		, teamCode = teamCode
		, year = nil
		, grade = "S"
		, available = (total >= 19)
		, total = total
	}
end

-- 두 팀이 같은 시즌 선수를 사용할 경우 호환 허용하지 않음
function checkAllowSeasonFamilyTeam(teamCode1, teamCode2)
	local seasonTeamCodes1 = teamInfos[teamCode1].seasonTeamCodes
	local seasonTeamCodes2 = teamInfos[teamCode2].seasonTeamCodes
	
	-- lua에서는 배열 형태가 아닌 table에서 length 값이 없기 때문에 두개의 set을 각각 for문을 돌려서 동일성을 비교한다
	for k, v in pairs(seasonTeamCodes1)
	do
		if not seasonTeamCodes2[k] then
			return true
		end
	end
	
	for k, v in pairs(seasonTeamCodes2)
	do
		if not seasonTeamCodes1[k] then
			return true
		end
	end
	
	return false
end

-- 시즌 선수 호환 팀일 경우 시즌 선수 카운트를 reset 함 
function resetSeasonPlayerCnt(deck)
	local info = teamInfos[deck.teamCode]
	if info.seasonTeamCodes[deck.teamCode] then
		return deck
	end
	
	-- 원본 덱을 복사한 다음 시즌 선수는 0으로 세팅한 후 반환
	local newDeck = cloneDeck(deck)
	newDeck.playerCnt = deck.playerCnt
	newDeck.seasonCnt = 0
	newDeck.aceCnt = deck.aceCnt
	newDeck.total = newDeck.playerCnt + newDeck.seasonCnt + newDeck.aceCnt
	
	return newDeck	
end

-- 덱을 내림차순으로 정렬
function sortDecksByTotal(decks)
	local size = #decks
	if size < 2 then
		return
	end
	
	for i = 1, size - 1 
	do
		for j = i + 1, size 
		do
			if decks[i].total < decks[j].total then
				local tmp = decks[i]
				decks[i] = decks[j]
				decks[j] = tmp
			end
		end
	end	
end

-- 팀연도덱에 맞는 선수 목록 반환
function getTeamYearDeckPlayers(players, teamCode, year)
	local playerIds = {}
	local seasonIds = {}
	local aceIds = {}
  	local monsterIds = {}
	
	local teamInfo = teamInfos[teamCode]
	
	for i, p in ipairs(players)
	do		
		if p.playerType == SEASON then
			-- 시즌 선수일 경우 시즌 선수 호환 체크
      		table.insert(seasonIds, p.playerId)
			--if teamInfo.seasonTeamCodes[p.teamCode] then
				--table.insert(seasonIds, p.playerId)
			--end
		elseif p.playerType == ACE then
			-- 에이스 선수일 경우 호환팀인지 체크
			if teamInfo.familyTeamCodes[p.teamCode] then
				table.insert(aceIds, p.playerId)
			end 
		else
			-- 나머지 선수 타입은 연도, 팀코드가 모두 맞아야함
			if p.teamCode == teamCode and p.year == year then
				table.insert(playerIds, p.playerId)
			end
      	    -- 몬스터 선수 제한이 모든덱을 대상으로 하므로 연도, 팀코드 관계없이 몬스터 카운트
            if p.playerType == MONSTER then
				table.insert(monsterIds, p.playerId)
			end
		end
	end
	
	return playerIds, seasonIds, aceIds, monsterIds
end

function getTeamYearDeckPlayerCount(players, teamCode, year)
	local playerIds, seasonIds, aceIds = getTeamYearDeckPlayers(players, teamCode, year)
	return #playerIds + #seasonIds + #aceIds
end

-- 연도덱에 맞는 선수 목록 반환
function getYearDeckPlayers(players, year)
	local playerIds = {}
	local seasonIds = {}
	local aceIds = {}
  	local monsterIds = {}
	
	for i, p in ipairs(players)
	do
		if p.playerType == SEASON then
			-- 연도덱에서 시즌 선수는 무조건 해당
			table.insert(seasonIds, p.playerId)
		elseif p.playerType == ACE then
			-- 연도덱에서 에이스 선수는 무조건 해당
			table.insert(aceIds, p.playerId)
		else
			-- 연도가 맞을 경우 해당
			if p.year == year then
				table.insert(playerIds, p.playerId)
			end      
      	    -- 몬스터 선수 제한이 모든덱을 대상으로 하므로 연도 관계없이 몬스터 카운트
            if p.playerType == MONSTER then
				table.insert(monsterIds, p.playerId)
			end
		end
	end
	
	return playerIds, seasonIds, aceIds, monsterIds
end

function getYearDeckPlayerCount(players, year)
	local playerIds, seasonIds, aceIds = getYearDeckPlayers(players, year)
	return #playerIds + #seasonIds + #aceIds
end

-- 팀덱에 맞는 선수 목록 반환
function getTeamDeckPlayers(players, teamCode, allowSeasonFamilyTeam)
	if allowSeasonFamilyTeam == nil then
		allowSeasonFamilyTeam = true
	end
	
	local playerIds = {}
	local seasonIds = {}
	local aceIds = {}
	local monsterIds = {}
	
	local teamInfo = teamInfos[teamCode]
	
	for i, p in ipairs(players)
	do		
		if p.playerType == SEASON then
		        table.insert(seasonIds, p.playerId)
			-- 시즌 선수일 경우 시즌 선수 호환 체크
			-- if teamCode == p.teamCode or (allowSeasonFamilyTeam and teamInfo.seasonTeamCodes[p.teamCode]) then
				-- table.insert(seasonIds, p.playerId)
			-- end
		elseif p.playerType == ACE then
			-- 에이스 선수일 경우 호환팀인지 체크
			if teamInfo.familyTeamCodes[p.teamCode] then
				table.insert(aceIds, p.playerId)
			end 
		else
			-- 나머지 선수 타입은 팀코드가 맞아야함
			if teamInfo.familyTeamCodes[p.teamCode] then
				table.insert(playerIds, p.playerId)
			end
       	    -- 몬스터 선수 제한이 모든덱을 대상으로 하므로 팀코드 관계없이 몬스터 카운트
            if p.playerType == MONSTER then
				table.insert(monsterIds, p.playerId)
			end
		end
	end
	
	return playerIds, seasonIds, aceIds, monsterIds
end

function getTeamDeckPlayerCount(players, teamCode, allowSeasonFamilyTeam)
	local playerIds, seasonIds, aceIds = getTeamDeckPlayers(players, teamCode, allowSeasonFamilyTeam)
	return #playerIds + #seasonIds + #aceIds
end

-- 덱 이름 반환
function getDeckName(deck)
	if deck.type == TEAM_YEAR then
		return string.format( DECK_NAME_FORMAT_TEAM_YEAR, getYearFormat(deck), teamInfos[deck.teamCode].name)
	elseif deck.type == TEAM then
		return string.format( DECK_NAME_FORMTAT_TEAM, teamInfos[deck.teamCode].name)
	elseif deck.type == YEAR then
		return string.format( DECK_NAME_FORMTAT_YEAR, getYearFormat(deck))
	elseif deck.type == DUAL_TEAM then
		local mainTeamCode, subTeamCode = splitTeamCode(deck.teamCode)
		
		return teamInfos[mainTeamCode].name .. "·" .. teamInfos[subTeamCode].name
	end

	return ""

end

function getYearFormat(deck)
	local tens = deck.year % 100

	if tens < 10 then
		return "0" .. tostring(tens)
	end

	return tens
end

-- 듀얼 팀 코드를 각 팀 코드로 분리해서 반환
function splitTeamCode(teamCode)
	local index = string.find(teamCode, "+")
	
	if not index then
		return nil
	end
	
	local mainTeamCode = string.sub(teamCode, 1, index - 1)
	local subTeamCode = string.sub(teamCode, index + 1)
	
	return shortTeamCodes[mainTeamCode], shortTeamCodes[subTeamCode]
end

-- 조건에 맞는 덱 보너스 스탯 반환
function getStat(deck)
	local deckStat = deckStats[deck.type][deck.grade]
	if not deckStat then
		return 0, 0
	end
	
	return deckStat[1], deckStat[2]
end

-- 덱 정보 세팅
function setInfoToDeck(deck)
	-- 스탯 정보 세팅
	local mainStat, subStat = getStat(deck)
	deck.mainStat = mainStat
	deck.subStat = subStat
	
	-- 이름 세팅
	local name = getDeckName(deck)
	deck.name = name
end

-- playerStatMap에 각 선수별 stat값을 넣어준다
function putAllPlayerStatMap(playerStatMap, playerIds, seasonIds, aceIds, stat)
	putPlayerStatMap(playerStatMap, playerIds, stat)
	putPlayerStatMap(playerStatMap, seasonIds, stat)
	putPlayerStatMap(playerStatMap, aceIds, stat)
end

-- player-stat map을 편하게 만들기 위한 util 함수
function putPlayerStatMap(map, playerIds, stat)
	if #playerIds > 0 then
		for i, playerId in ipairs(playerIds)
		do
			map[playerId] = stat
		end
	end
end

-- 패밀리 팀 이름 반환. 인자값으로 들어오는 teamCode가 가장 처음 등장
function getSortedFamilyNames(teamCode)
	local familyNames = {}
	
	local teamInfo = teamInfos[teamCode]
	table.insert(familyNames, teamInfo.name)
	
	for k, v in pairs(teamInfo.familyTeamCodes)
	do
		if teamCode ~= k then
			table.insert(familyNames, teamInfos[k].name)
		end
	end
	
	return familyNames
end

-- 사용가능한 덱 목록에서 최종 반환되는 덱 목록을 생성해서 반환
function makeTotalDeckList(decks, currDeck)
	local totalDecks = {}
	
	for i, deck in ipairs(decks)
	do
		table.insert(totalDecks, deck)
		
		if deck.available then
			if deck.type == TEAM_YEAR or deck.type == TEAM or deck.type == YEAR then
				if deck.grade == "S" then
					if isSameTypeDeck(deck, currDeck) and (currDeck.grade == "A" or currDeck.grade == "B" or currDeck.grade == "C") then
						table.insert(totalDecks, currDeck)
					end
					 
				elseif deck.grade == "A" then
					local other = cloneDeck(deck)
					other.grade = "S"
					other.available = false
					table.insert(totalDecks, other)
					
					if isSameTypeDeck(deck, currDeck) and (currDeck.grade == "B" or currDeck.grade == "C") then
						table.insert(totalDecks, currDeck)
					end
					
				elseif deck.grade == "B" then
					local other = cloneDeck(deck)
					other.grade = "A"
					other.available = false
					table.insert(totalDecks, other)
					
					if isSameTypeDeck(deck, currDeck) and currDeck.grade == "C" then
						table.insert(totalDecks, currDeck)
					end
					
				else
					local other = cloneDeck(deck)
					other.grade = "B"
					other.available = false
					table.insert(totalDecks, other)
				end
			end
		end

	end
	
	return totalDecks
end

function cloneDeck(deck)
	return {
		type = deck.type
		, teamCode = deck.teamCode
		, year = deck.year
		, grade = deck.grade
		, total = deck.total
		, available = deck.available
	}
end

function isSameTypeDeck(deck1, deck2)
	if not deck2 then
		return false
	end
	
	return deck1.type == deck2.type and deck1.year == deck2.year and deck1.teamCode == deck2.teamCode			
end

function getTeamDeckCondStr(teamCode, playerCnt)
	-- 팀덱 조건 설명
	local familyNames = getSortedFamilyNames(teamCode)
		
	if #familyNames == 1 then
		return string.format( DECK_DESC_FORMTAT_COMMON, familyNames[1], playerCnt)
	elseif #familyNames == 2 then
		return string.format( DECK_DESC_FORMTAT_FAMILY_01, familyNames[1], familyNames[2], playerCnt)
    else
		return string.format( DECK_DESC_FORMTAT_FAMILY_02, familyNames[1], familyNames[2], familyNames[3], playerCnt)
	end
end

function getDualTeamDeckCondStr(teamCode, minPlayerCnt, maxPlayerCnt)
	local playerCnt
	if maxPlayerCnt then
		playerCnt = minPlayerCnt .. "~" .. maxPlayerCnt
	else
		playerCnt = tostring(minPlayerCnt)
	end
	
	-- 팀덱 조건 설명
	local familyNames = getSortedFamilyNames(teamCode)
		
	if #familyNames == 1 then
		return string.format("%s선수 %s명", familyNames[1], playerCnt)
	else
		return string.format("%s(%s)선수 %s명", familyNames[1], familyNames[2], playerCnt)
	end
end

-- 리스트 덤프
function dumpList(list)
	for i, v in ipairs(list)
	do
		for j, v1 in pairs(v)
		do
			print(j, v1)
		end

		print()
	end
end

-- array 덤프
function dumpArray(array)
	for i, v in ipairs(array)
	do
		print(i, v)
	end
end

-- object 덤프
function dumpObj(obj)
	for k, v in pairs(obj)
	do
		print(k, v)
	end
	
	print()
end

