-- NORMAL 0
-- SEASON 1
-- SPECIAL 2
-- MONSTER 3
-- ACE 4



local g_cost = {}
g_cost[1] = {min = 40, max = 49} 
g_cost[2] = {min = 50, max = 54}
g_cost[3] = {min = 55, max = 59}
g_cost[4] = {min = 60, max = 64}
g_cost[5] = {min = 65, max = 69}
g_cost[6] = {min = 70, max = 74}
g_cost[7] = {min = 75, max = 79}
g_cost[8] = {min = 80, max = 89}


-- 에이스 특별 레시피, 사용되지 않지만 향후를 위해 남겨둠.
local g_aceReceipe = {}


local g_apBtnStatus = BTN_NONE
local g_cashBtnStatus = BTN_NONE

-- 트레이드 결과 확률 계산
function calculate(players, useAp, useCash, usePreventItem)
    print("players : " .. #players)
    
    -- 가장 높은 코스트
    local ace = -1
    -- 가장 낮은 코스트
    local minCost = 9
    -- 평균 코스트
    local avg = 0.0
    -- 몬스터 카드 개수
    local mon = 0
    -- 스페셜 카드 개수
    local spn = 0
    -- 노멀 카드 개수
    local non = 0

    -- 시즌 선수 개수
    local seasonCnt = 0
    local previewCnt = 0

    local _value = 0

    local _monster = "moster"
    local _special = "special"
    local _normal = "normal"
    local _n_up = "n-up"
    local _s_up = "s-up" 
    local _season = "season"
    local _preview = "preview"

    local target = {}
    local resTarget = {}

    g_apBtnStatus = BTN_NONE
    g_cashBtnStatus = BTN_NONE

    target[_normal] = { valid = false, fixed = false, value = 0, prob = 0.0, mul = 1, up = 0, cost = 0, min = 0, max = 0, cardType = NORMAL }
    target[_n_up] = { valid = false, fixed = false, value = 0, prob = 0.0, mul = 1, up = 1, cost = 0, min = 0, max = 0, cardType = NORMAL }
    target[_special] = { valid = false, fixed = false, value = 0, prob = 0.0, mul = 10, up = 0, cost = 0, min = 0, max = 0, cardType = SPECIAL }
    target[_s_up] = { valid = false, fixed = false, value = 0, prob = 0.0, mul = 10, up = 1, cost = 0, min = 0, max = 0, cardType = SPECIAL }
    target[_monster] = { valid = false, fixed = false, value = 10000, prob = 0.0, mul = 100, up = 0, cost = 0, min = 0, max = 0, cardType = MONSTER }
    target[_season] = { valid = false, fixed = false, value = 0, prob = 0.0, mul = 1, up = 0, cost = 2, min = 0, max = 0, cardType = SEASON }
    target[_preview] = { valid = false, fixed = false, value = 0, prob = 0.0, mul = 1, up = 0, cost = 4, min = 0, max = 0, cardType = PREVIEW }


    for i, p in ipairs(players) do
        avg = avg + p.cost

        if p.cost > ace then
            ace = p.cost
        end
    
        if p.cost < minCost then
            minCost = p.cost
        end 

        if p.playerType == MONSTER then
            mon = mon + 1
            _value = _value + target[_monster].value
        elseif p.playerType == SPECIAL then
            spn = spn + 1
            _value = _value + math.pow( 2, p.cost - 1 ) * 10
        elseif p.playerType == SEASON then
            seasonCnt = seasonCnt + 1
            _value = _value + 1
        elseif p.playerType == PREVIEW then
            previewCnt = previewCnt + 1
            _value = _value + 1
        else
            non = non + 1
            _value = _value + math.pow( 2, p.cost - 1 )
        end
    end
    
    if ( seasonCnt < 4 and seasonCnt > 1 ) or ( previewCnt < 4 and previewCnt > 1 ) or #players < 2 then
        for key, t in pairs(target) do

            t.prob = 0
            if t.prob > 0 then      
                table.insert(resTarget, t)
            end
        end

        return resTarget
    end

    if previewCnt == 4 then
        for key, t in pairs(target) do

            t.prob = 0

            if key == _preview then
                t.min = g_cost[ t.cost ].min
                t.max = g_cost[ t.cost ].max

                t.prob = 100
            end

            if t.prob > 0 then
                table.insert(resTarget, t)
            end
        end

        return resTarget
    end

    
    if seasonCnt == 4 then
        for key, t in pairs(target) do

            t.prob = 0

            if key == _season then
                t.min = g_cost[ t.cost ].min
                t.max = g_cost[ t.cost ].max

                t.prob = 100
            end

            if t.prob > 0 then
                table.insert(resTarget, t)
            end
        end

        return resTarget
    end

    -- 카드 갯 수를 다 더한다.
    local strategy = mon + spn + non
    local grade = ""
    local targetValue = 0

    local fixedProb = 0.0
    local fixedValue = 0.0
    local totalValue = 0.0


    local baseCost = 0

    if mon > 0 then
        grade = _monster
        targetValue = _value * 0.4
        baseCost = 8
    elseif spn > 0 then
        grade = _special
        targetValue = _value * 0.6
        baseCost = math.floor( log2( targetValue / 9.1 ) + 1 ) 
    else 
        grade = _normal
        targetValue = _value * 0.9
        baseCost  = math.floor( log2( targetValue / 0.9 ) )
    end
    
    if baseCost < 1 then
        baseCost = 1
    end

    if baseCost > 8 then
        baseCost = 8
    end

  --   for key, t in pairs(target) do
  --       local val = t
    
        -- if val.cost < 1 then
  --        val.cost = 1
  --    end
    
     --     if val.cost > 8 then
  --        val.cost = 8
  --    end
  --   end

    if grade == _monster then
        target[_monster].valid = true
        target[_special].valid = true

        if non > 0 then
            target[_normal].valid = true
            fixedProb = fixedProb + 0.1
            target[_normal].prob = 0.1
            target[_normal].fixed = true
        end
    elseif grade == _special then
        target[_normal].valid = true;
        if spn > 1 then
            if baseCost > 5 and targetValue > 1164.8 then
                target[_monster].valid = true
                fixedProb = fixedProb + 0.1
                target[_normal].prob = 0.1
                target[_normal].fixed = true
                target[_special].valid = true

                if baseCost < 8 then
                    target[_s_up].valid = true;
                    fixedProb = fixedProb + 0.1
                    target[_s_up].prob = 0.1
                    target[_s_up].fixed = true
                end
            else 
                fixedProb = fixedProb + 0.05
                target[_special].prob = 0.05
                target[_special].fixed = true
                target[_special].valid = true
                target[_s_up].valid = true
            end  

        else 
            target[_s_up].valid = true
            if baseCost > 1 then
                fixedProb = fixedProb + 0.05
                target[_special].prob = 0.05
                target[_special].fixed = true
                target[_special].valid = true
            end
        end
    elseif grade == _normal then
        if baseCost == 1 then
            target[_s_up].valid = true
        else 
            target[_special].valid = true
        end

        if strategy < 4 or baseCost > 1 then
            target[_normal].valid = true
            if baseCost < 8 then
                fixedProb = fixedProb + 0.3 
                target[_normal].prob = 0.3
                target[_normal].fixed = true
            end
        end

        if baseCost < 8 then
            target[_n_up].valid = true
        end
    end

    for key, t in pairs(target) do
        local val = t

        if key ~= _monster then
            val.value = math.pow( 2, baseCost - 1 + val.up ) * val.mul
        end 

        -- if key == _special then
        --  val.value = math.pow( 2, target[_special].cost - 1 + val.up ) * val.mul
     --     elseif key == _normal then
        --  val.value = math.pow( 2, target[_normal].cost - 1 + val.up ) * val.mul
     --    end 

        if val.fixed then
            fixedValue = fixedValue + val.value * val.prob
            val.value = 0
        end

        if val.valid then
            totalValue = totalValue + val.value
        end
    end

    for key, t in pairs(target) do
        local val = t

        if val.valid and val.prob == 0.0 then
            local parent = val.value * 2 - totalValue
            local child = targetValue - fixedValue + ( totalValue -  val.value ) * ( fixedProb - 1 )
            val.prob = child / parent
        end
    end

    specialProb = target[_special].prob + target[_s_up].prob
    local apUp = specialProb * 0.15 + 0.05
    local upgrade = ""

    if useAp then
        if target[_s_up].valid then
            upgrade = _s_up
        elseif target[_special].valid then
            upgrade = _special
        end

        target[upgrade].prob = target[upgrade].prob + apUp

        if apUp > target[_normal].prob then
            apUp = apUp - target[_normal].prob
            target[_normal].prob = 0
        else
            target[_normal].prob = target[_normal].prob - apUp
            apUp = 0
        end

        if apUp > target[_n_up].prob then
            apUp = apUp - target[_n_up].prob
            target[_n_up].prob = 0
        else
            target[_n_up].prob = target[_n_up].prob - apUp
            apUp = 0
        end
        
        if apUp > target[_special].prob then
            apUp = apUp - target[_special].prob
            target[_special].prob = 0
        else
            target[_special].prob = target[_special].prob - apUp
            apUp = 0
        end

        if apUp > target[_s_up].prob then
            apUp = apUp - target[_s_up].prob
            target[_s_up].prob = 0
        else
            target[_s_up].prob = target[_s_up].prob - apUp
            apUp = 0
        end

        if target[upgrade].prob > 1 then
            target[upgrade].prob = 1
        end
    end

    local cashUp = 0
    upgrade = ""

    if useCash then
        if target[_monster].valid then
            upgrade = _monster
            cashUp = target[_monster].prob * 0.3 + 0.03
        elseif target[_s_up].valid then
            upgrade = _s_up
            cashUp = specialProb * 0.5 + 0.1
        elseif target[_special].valid then
            upgrade = _special
            cashUp = specialProb * 0.5 + 0.1
        end

        target[upgrade].prob = target[upgrade].prob + cashUp
        if target[upgrade].prob > 1 then
            target[upgrade].prob = 1
        end

        if cashUp > target[_normal].prob then
            cashUp = cashUp - target[_normal].prob
            target[_normal].prob = 0
        else
            target[_normal].prob = target[_normal].prob - cashUp
            cashUp = 0
        end

        if cashUp > target[_n_up].prob then
            cashUp = cashUp - target[_n_up].prob
            target[_n_up].prob = 0
        else
            target[_n_up].prob = target[_n_up].prob - cashUp
            cashUp = 0
        end
        
        if upgrade ~= _special then
            if cashUp > target[_special].prob then
                cashUp = cashUp - target[_special].prob
                target[_special].prob = 0
            else
                target[_special].prob = target[_special].prob - cashUp
                cashUp = 0
            end
        end

        if upgrade ~= _s_up then
            if cashUp > target[_s_up].prob then
                cashUp = cashUp - target[_s_up].prob
                target[_s_up].prob = 0
            else
                target[_s_up].prob = target[_s_up].prob - cashUp
                cashUp = 0
            end
        end
    end

    if target[_s_up].valid or target[_special].valid then
        g_apBtnStatus = BTN_SPECIAL
        g_cashBtnStatus = BTN_SPECIAL
    end

    if target[_monster].valid then
        g_cashBtnStatus = BTN_MONSTER
    end

    local minCost = 0
    local maxCost = 0

    local probTotal = 0;
    local maxProbKey = _normal
    local minProbKey = _normal
    local maxProb = target[_normal].prob;
    local minProb = target[_normal].prob;
    for key, t in pairs(target) do
        local val = t

        val.cost = baseCost

        minCost = math.max( baseCost, 1 )
        maxCost = math.min( baseCost, 8 )

        if key == _s_up or key == _n_up then
            if val.prob > 0.0 then
                maxCost = math.min( val.cost + 1, 8 )
                minCost = math.max( maxCost, 1 )
            end
        end

        val.min = g_cost[ minCost ].min
        val.max = g_cost[ maxCost ].max

        val.prob = round( val.prob * 100.0 )

        if (minProb > val.prob and val.prob > 0.0) or (minProb <= 0.0 and val.prob > 0.0) then
            minProbKey = key
            minProb = val.prob
        end

        if maxProb < val.prob or maxProb <= 0.0 then
            maxProbKey = key
            maxProb = val.prob
        end

        if key == _monster then

            val.prob = math.min( val.prob, 100 )

            if val.prob > 0.0 then
                val.min = g_cost[ 6 ].min
                val.max = g_cost[ 8 ].max
            end
        end

        if val.prob > 0.0 then
            probTotal = probTotal + math.floor(val.prob)
        end
    end

    if probTotal > 100 then
        target[maxProbKey].prob = target[maxProbKey].prob - (probTotal - 100)
    end

    if probTotal < 100 then 
        target[minProbKey].prob = 100 - probTotal + target[minProbKey].prob
    end

    for key, t in pairs(target) do
        local val = t

        if val.prob > 0.0 then
            table.insert(resTarget, t)
        end
    end

    return resTarget
end

function round(num) 
    if num >= 0 then return math.floor(num+.5)
    else return math.ceil(num-.5) end
end

function log2(value) 
    return math.log( value ) / math.log( 2 );
end

function getNormalizeRandom(target) 
    local sumProb = getSumProb( target )

    return math.random() * sumProb
end

function getSumProb(target)
    local sumProb = 0.0

    for key, t in pairs(target) do
        local val = t

        if val.valid then
            sumProb = sumProb + val.prob
        end 
    end

    return sumProb
end


function isAceReceipe(playerId)
    local isReceipe = false
    local targetPlayerId = 0

    print(playerId)

    for i, v in ipairs(g_aceReceipe) do
        if playerId == v.first then
            isReceipe = true
            targetPlayerId = v.second
        elseif playerId == v.second then
            isReceipe = true
            targetPlayerId = v.first
        end
    end

    return isReceipe, targetPlayerId
end

function isAceReceipeComplete(players)
    local isReceipe = false
    local isComplete = false
    local targetPlayerId = 0

    if #players == 0 or #players > 2 then
        return isReceipe, isComplete, targetPlayerId
    end

    isReceipe, targetPlayerId = isAceReceipe(players[1].playerId)

    if isReceipe and #players == 2 then
        if targetPlayerId == players[2].playerId then
            isComplete = true
        else
            isReceipe = false
        end

        targetPlayerId = 0
    end

    return isReceipe, isComplete, targetPlayerId
end

function getApBtnStatus()
    return g_apBtnStatus
end

function getCashBtnStatus()
    return g_cashBtnStatus
end
